% pcda cross validation 2 classes, 10 times outer loop

%I: X, classes, maxpc

function [mis,npc] = PCDA2cv(X,classes,maxpc);

outer1=randperm(20)';
outer2=[20+randperm(19)'; 0];
m1=randperm(18);
m2=randperm(18);

% outer cross (10 fold)
in=[1 2];
for outer=1:10
    ind_outer=[outer1(in); outer2(in)];
    train =delsamps([0:39]', 1+[outer1(in); outer2(in)]);
    ind(outer,:)=[ind_outer' train'];
    ind_outer=ind_outer(ind_outer~=0);
    train=train(train~=0);
    test_outer=X(ind_outer,:);
    Tclass_outer=classes(ind_outer);
    X_outer=X(train,:);
    Xclass_outer=classes(train);

    %idx for next loop
    middle1=delsamps(outer1,in); %remove idx that has been used
    middle1=middle1(m1);%permute remaining idx
    middle2=delsamps(outer2,in);
    middle2=middle2(m2);
    % inner cross (9 fold)
    o=[1 2];
    for middle=1:9
        ind_middle=[middle1(o) middle2(o)];
        ind_middle=ind_middle(ind_middle~=0);
        test_middle=X(ind_middle,:);
        Tclass_middle=classes(ind_middle);
        ind_middle=[ind_outer; ind_middle];
        X_middle=delsamps(X,ind_middle);
        Xclass_middle=delsamps(classes,ind_middle);
        o=o+2;

        % build models using different numbers of components
        for pc=2:maxpc
            [middleclass,D]=PCDApred(test_middle,X_middle,Xclass_middle,pc);
            loss(middle,pc)=length(find(middleclass'~=[Tclass_middle]));
        end

        % find #pcs
    end % inner cross ends

    % find best number of components
    som=sum(loss);
    [m npc(outer)]=min(som(2:maxpc));
    npc(outer)=npc(outer)+1;

    %2cv prediction erros
    [class(ind_outer),d]=PCDApred(test_outer,X_outer,Xclass_outer,npc(outer));

    in=in+2;
end %outer cross ends
mis=length(find (class'~=classes));
